        #include <bits/stdc++.h>
        #define lend "\n"
        #define F first
        #define S second

        typedef long long ll;
        typedef unsigned long long ull;

        using namespace std;

        vector<int> used(2e5, -1);

        map<int, vector<int>> mp;

        void dfs(vector<vector<int>> &g, int v, int col) {
            used[v] = col;
            mp[col].push_back(v);
            for (int u : g[v]) {
                if (used[u] == -1) {
                    dfs(g, u, col);
                }
            }
        }

        inline void solve() {
            int n; cin >> n;
            vector<vector<int>> g(n+1, vector<int>());
            for (int i = 1; i <= n; i++) {
                int val; cin >> val;
                g[val].push_back(i);
                g[i].push_back(val);
            }
            ll cnt = 0;
            for (int i = 1; i <= n; i++) {
                if (used[i] == -1) {
                    dfs(g, i, ++cnt);
                }
            }

            ll ans = 0;
            vector<vector<int>> groups(2, vector<int>());

            for (auto &p : mp) {
                if (p.second.size() % 2 == 1 and p.second.size() > 1) {
                    ans++;
                    for (int i = 0; i < p.second.size()-1; i++) {
                        groups[i%2].push_back(p.second[i]);
                    }
                }
                else {
                    for (int i = 0; i < p.second.size(); i++) {
                        groups[i%2].push_back(p.second[i]);
                    }
                }
            }
            cout << ans << lend;
            for (auto p : groups) {
                for (auto &i : p) {
                    cout << i << " ";
                }
                cout << lend;
            }
        }

        int main() {
            ios_base::sync_with_stdio(false);
            cin.tie(NULL);
            cout.tie(NULL);
            int tt = 1;
            // cin >> tt;
            while(tt--) {
                solve();
                cout << lend;
            }
        }