#include <iostream>
#include <vector>
#include <algorithm>

#define lend "\n"
#define F first
#define S second

typedef long long ll;
typedef unsigned long long ull;

using namespace std;

const int MOD = 1e9+9;

inline void solve() {
    int n, k; cin >> n >> k;
    vector<vector<ll>> dp(n+1488, vector<ll>(n+1488, 0));
    dp[2][1]=1;
    dp[2][0] =1;
    dp[3][1] = 3;
    dp[3][0] = 1;
    for (int i = 4; i <= n; i++) {
        if (i % 2 == 0) {
            for (int j = 0; j <= n; j++) {
                dp[i][j] = dp[i-2][j];
                dp[i][j+2] = dp[i-2][j];
                dp[i][j] %= MOD;
                dp[i][j+2] %= MOD;
            }
        }
    }
    cout << dp[n][k] << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int tt = 1;
    // cin >> tt;
    while(tt--) {
        solve();
        cout << lend;
    }
}