#include <bits/stdc++.h>

#define F first
#define S second

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int inf = 1e18;

vector<ll> used(1e5, 0);

void dfs(vector<vector<pair<ll, char>>> &g, ll v, int start, char val) {
    used[v] = 1;
    for (auto x : g[v]) {
        if (v == start and used[x.first] == 0) {
            dfs(g, v, start, x.first);
        } else if (v != start and used[x.first] == 0 and x.second == val) {
            dfs(g, v, start, val);
        }
    }
}
inline void solve2(ll n, ll m);

inline void solve() {
    ll n, m; cin >> n >> m;

    vector<vector<pair<ll, char>>> g(n*m+100, vector<pair<ll, char>>());
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < m; j++) {
            char val; cin >> val;
            g[i*n + j].push_back({i*n + j+1, val});
            g[i*n + j+1].push_back({i*n + j, val});
        }
    }

    for (int i = 0; i < n-1; i++) {
        for (int j = 1; j <= m; j++) {
            char val; cin >> val;
            g[i*n + j].push_back({i*n+n + j, val});
            g[i*n+n + j].push_back({i*n + j, val});
        }
    }

    int q; cin >> q;
    while (q--) {
        for (auto &i : used) i = 0;
        ll a, b, c ,d; cin >> a >> b >> c >> d;
        dfs(g, (a-1) * b, (a-1) * b);
        if (used[(c-1)*d] == 1)cout << 1;
        else cout << 2;
        cout << endl;
    }


}
inline void solve2(ll n, ll m) {
    vector<char> g(m);
    for (int i = 0; i < m-1; i++) {
        cin >> g[i];
    }
    int q; cin >> q;
    while (q--) {
        ll a, b, c ,d; cin >> a >> b >> c >> d;
        if (d < b) swap(d, b);
        set<char> s;
        while (b < d-1) {
            s.insert(g[b]);
            b++;
        }
        cout << s.size() << endl;
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int tt = 1;
    // cin >> tt
    while(tt--) {
        solve();
        cout << endl;
    }
}